/// \file
/// \author Matthew Allen
#ifndef _GFILTER_UI_H_
#define _GFILTER_UI_H_

#include "GTree.h"

class GFilterViewPrivate;

enum GFilterNode
{
	LNODE_NULL,
	LNODE_AND,
	LNODE_OR,
	LNODE_COND,
	LNODE_NEW
};

enum GFilterMenu
{
	FMENU_FIELD,
	FMENU_OP,
	FMENU_VALUE
};

class GFilterView;
class GFilterItem;

typedef int (*FilterUi_Menu)(GFilterView *View, GFilterItem *Item, GFilterMenu Menu, GRect &r, int Data);

class GFilterItem : public GTreeItem
{
	class GFilterItemPrivate *d;

protected:
	void _PourText(GdcPt2 &Size);
	void _PaintText(GSurface *pDC, COLOUR Fore, COLOUR Back);

public:
	GFilterItem(GFilterViewPrivate *Data, GFilterNode Node = LNODE_NEW);
	~GFilterItem();

	bool GetNot();
	char *GetField();
	char *GetOp();
	char *GetValue();

	void SetNot(bool b);
	void SetField(char *s);
	void SetOp(char *s);
	void SetValue(char *s);

	GFilterNode GetNode();
	void SetNode(GFilterNode n);

	void OnMouseClick(GMouse &m);
};

/// Filter user interface using a tree structure.
class GFilterView : public GTree
{
	class GFilterViewPrivate *d;

public:
	GFilterView(FilterUi_Menu Callback = 0, int Data = 0);
	~GFilterView();

	bool ShowLegend();
	void ShowLegend(bool b);
	GFilterItem *Create(GFilterNode Node = LNODE_NEW);

	GRect &GetClient(bool InClientSpace = true);
	void OnPaint(GSurface *pDC);
};

#endif