/*hdr
**	FILE:			Memory.h
**	AUTHOR:			Matthew Allen
**	DATE:			30/11/93
**	DESCRIPTION:	Memory subsystem header
**
**
**	Copyright (C) 1995, Matthew Allen
**		fret@memecode.com
*/

#ifndef __MEMORY_H
#define __MEMORY_H

#include <string.h>
#include "LgiDefs.h"
#include "LgiInc.h"

/// \returns true if heap is ok.
LgiFunc bool LgiCheckHeap();

/// \return true if the block of memory referenced by 'p' is readable for Len bytes.
LgiFunc bool LgiCanReadMemory
(
	void *p,
	int Len
	#ifdef __cplusplus
	 = 1
	#endif
);

/// Dumps info about the currently allocated blocks of memory
/// to 'filename'. Only work when LGI_MEM_DEBUG defined.
/// \returns true on success.
LgiFunc bool LgiDumpMemoryStats(char *filename);


// Set this to '1' to switch on memory tracking, else '0'.
#if 0

	#include <stdlib.h>
	
	/// '1' indicates that we want to track memory usage.
	/// To use this feature every DLL should include the
	/// source file 'GNew.cpp' and each EXE should include
	/// 'LgiMain.cpp' OR 'GNew.cpp' for this to work.
	#define LGI_MEM_DEBUG		1

	#ifdef __cplusplus
	void *operator				new(unsigned size);
	void *operator				new[](unsigned size);
	void operator				delete(void *p);
	#endif

	LgiFunc void *lgi_malloc(size_t size);
	LgiFunc void lgi_free(void *ptr);

	#define malloc				lgi_malloc
	#define free				lgi_free

#else

	// Defined in LgiDefs.h

#endif

#endif
