#ifndef __GMRU_H
#define __GMRU_H

// Message defines
#define	IDM_OPEN			15000
#define	IDM_SAVEAS			15001

// Classes
class LgiClass GMru
{
private:
	class GMruPrivate *d;
	void _Update();

protected:
	virtual bool _OpenFile(char *File);
	virtual bool _SaveFile(char *File);

	virtual char *_GetCurFile();
	virtual void GetFileTypes(GFileSelect *Dlg, bool Write);
	virtual GFileType *GetSelectedType();
	void DoFileDlg(bool Open);

public:
	GMru();
	virtual ~GMru();

	// Impl
	bool Set(GSubMenu *parent, int size = -1);
	bool Serialize(ObjProperties *Props, char *Prefix, bool Write);
	char *AddFile(char *FileName, bool Update = true);
	void RemoveFile(char *FileName, bool Update = true);
	int OnEvent(GMessage *Msg);

	// Events
	virtual bool OpenFile(char *FileName) = 0;
	virtual bool SaveFile(char *FileName) = 0;
};

#endif
