/// \file
/// \author Matthew Allen (fret@memecode.com)
/// /brief A progress control

#ifndef _GPROGRESS_H_
#define _GPROGRESS_H_

/// Progress bar control
class LgiClass GProgress :
	public GControl,
	public Progress,
	public ResObject
{
	COLOUR c;

public:
	GProgress(int id, int x, int y, int cx, int cy, char *name);
	~GProgress();

	/// Sets the range that the Value() is between
	void SetLimits(int64 l, int64 h);
	/// Sets the point between the limits that defines where the progress is up to
	void Value(int64 v);
	int64 Value();
	int OnEvent(GMessage *Msg);

	#ifdef WIN32
	bool SetForegroundFill(GViewFill *Fill);
	#else
	void GetLimits(int64 &l, int64 &h);
	void OnPaint(GSurface *pDC);
	void Colour(COLOUR Col);
	COLOUR Colour();
	#endif
};

#endif
