/// \file
/// \author Matthew Allen

#ifndef _GXML_TREE_UI_H_
#define _GXML_TREE_UI_H_

#include "GXmlTree.h"
#include "GVariant.h"

/// This class allows you to serialize data between the user interface and a
/// GXmlTag instance. Useful for storing user visible application settings in
/// XML.
class GXmlToUi
{
	class GXmlToUiPriv *d;

public:
	GXmlToUi();
	~GXmlToUi();

	/// Create attribute <-> UI element mapping
	void Map(char *Attr, int UiIdent, int Type = GV_NULL);
	/// Clear all mappings
	void EmptyMaps();
	/// Convert data to/from an XML tag
	bool Convert(GDom *Tag, GViewI *ui, bool ToUI);
	/// Disable/enable all control
	void EnableAll(GViewI *ui, bool Enable);
};

#endif