
#ifndef __OS_CLASS_H
#define __OS_CLASS_H

#include "GRect.h"

class GView;
class GRect;
class GMessage
{
	int Msg, Arg1, Arg2;

public:
	GMessage(int M = 0, int A = 0, int B = 0)
	{
		Msg = M;
		Arg1 = A;
		Arg2 = B;
	}
	
	int &m() { return Msg; }
	int &a() { return Arg1; }
	int &b() { return Arg2; }
};

#define MsgCode(Msg)				(Msg ? ((GMessage*)Msg)->m() : 0)
#define MsgA(Msg)					(Msg ? ((GMessage*)Msg)->a() : 0)
#define MsgB(Msg)					(Msg ? ((GMessage*)Msg)->b() : 0)

extern GMessage CreateMsg(int m, int a, int b);

class OsAppArguments
{
public:
	int Args;
	char **Arg;
};

class OsApplication
{
public:
	OsApplication(int args, char **arg);
	
	void Run();
};

class OsPoint
{
public:
	int x, y;

	OsPoint(int X = 0, int Y = 0)
	{
		x = X;
		y = Y;
	}
};

class YObject
{
public:
	virtual ~YObject() {}
};

class YView : public YObject
{
	class YViewPrivate *d;

protected:
	void SetHandle(class Y::Widget *p);

public:
	YView(GView *v, bool p = true);
	~YView();

	GView *_GetWndPtr();
	void _SetWndPtr(GView *v);
	void _SetDeleteMe();

	Y::Widget *handle();
	YView *parentWidget();
	virtual bool reparent(void *p, OsPoint &p, bool vis);
	bool isTabStop();
	void isTabStop(bool i);
	virtual GRect &geometry();
	virtual void setGeometry(int x, int y, int w, int h);
	void repaint();
	void repaint(int x, int y, int w, int h);
	void update();
	void update(int x, int y, int w, int h);
	void setText(char *s);
	bool isEnabled();
	void setEnabled(bool b);
	virtual void show();
	virtual void hide();
	void setFocus();
	void clearFocus();
	bool hasFocus();
	void grabMouse();
	void ungrabMouse();
	OsPoint &mapToGlobal(OsPoint &p);
	OsPoint &mapFromGlobal(OsPoint &p);
	int wantKeys();
	void wantKeys(int w);
};

typedef YView *OsView;

class YWindow : public YView, public SigC::Object
{
	class YWindowPrivate *d;
	
	void OnDraw();
	void OnRequestExit();
	
public:
	YWindow(GWindow *t);
	~YWindow();

	bool reparent(void *p, OsPoint &p, bool vis);
	GRect &geometry();
	void setGeometry(int x, int y, int w, int h);
	void show();
	void hide();
};

typedef YWindow *OsWindow;

class YPainter : public YObject
{
public:
	void SetClient(GRect *r);
};

typedef YPainter *OsPainter;

class YFont : public YObject
{
public:
	int GetAscent();
};
typedef YFont *OsFont;

typedef void *OsBitmap;
typedef void *OsSubMenu;
typedef void *OsMenuItem;
typedef pthread_t OsThread;
typedef YView DefaultOsView;
typedef int OsProcess;

extern bool _GetKdeFont(char *FontType, char *Font, int FontBufSize, int &PointSize);

#endif