/*hdr
**      FILE:           GTabLayout.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           28/6/99
**      DESCRIPTION:    Resizing Tab View
**
**      Copyright (C) 1999, Matthew Allen
**              fret@memecode.com
*/

#include <stdio.h>

#include "Lgi.h"
#include "GTabLayout.h"

GTabLayout::GTabLayout() :
	GTabView(100, 0, 0, 100, 100, "GTabLayout")
{
	Edge = true;
}

GTabLayout::~GTabLayout()
{
}

bool GTabLayout::Border()
{
	return Edge;
}

void GTabLayout::Border(bool b)
{
	Edge = b;
}

bool GTabLayout::Pour(GRegion &r)
{
	GRect *Best = FindLargest(r);
	if (Best)
	{
		SetPos(*Best, true);
		return true;
	}
	return false;
}

void GTabLayout::OnPosChange()
{
	GTabView::OnPosChange();
	
	for (GTabPage *Page = Tabs.First(); Page; Page = Tabs.Next())
	{
		// GRect Rgn(GetClient());
		GRect Rgn(Page->GetPos());
		Rgn.Offset(-Rgn.x1, -Rgn.y1);
		if (Edge)
		{
			Rgn.Size(6, 6);
		}
		GRegion r(Rgn);

		for (GViewI *w = Page->Children.First(); w; w = Page->Children.Next())
		{
			GLayout *v = dynamic_cast<GLayout*>(w);
			if (v)
			{
				v->Pour(r);
			}
		}
	}
}

