#include <stdio.h>
#include "Lgi.h"


/////////////////////////////////////////////////////////////////////////////
// Image Help
#include "ImageHlp.h"

typedef BOOL (__stdcall *SYMINITIALIZEPROC)( HANDLE, LPSTR, BOOL );
typedef BOOL (__stdcall *SYMCLEANUPPROC)( HANDLE );

typedef BOOL (__stdcall * STACKWALKPROC)
            ( DWORD, HANDLE, HANDLE, LPSTACKFRAME, LPVOID,
             PREAD_PROCESS_MEMORY_ROUTINE,PFUNCTION_TABLE_ACCESS_ROUTINE,
             PGET_MODULE_BASE_ROUTINE, PTRANSLATE_ADDRESS_ROUTINE );

typedef LPVOID (__stdcall *SYMFUNCTIONTABLEACCESSPROC)( HANDLE, DWORD );

typedef DWORD (__stdcall *SYMGETMODULEBASEPROC)( HANDLE, DWORD );

typedef BOOL (__stdcall *SYMGETSYMFROMADDRPROC)
                             ( HANDLE, DWORD, PDWORD, PIMAGEHLP_SYMBOL );

typedef BOOL (__stdcall *proc_SymGetLineFromAddr)(	HANDLE hProcess,
													DWORD dwAddr,
													PDWORD pdwDisplacement,
													PIMAGEHLP_LINE Line);

typedef DWORD (__stdcall *proc_SymGetOptions)(VOID);
typedef DWORD (__stdcall *proc_SymSetOptions)(DWORD SymOptions);

class GDebugHelp : public GLibrary
{
public:
	HANDLE						hProcess;

	SYMINITIALIZEPROC			SymInitialize;
	SYMCLEANUPPROC				SymCleanup;
	STACKWALKPROC				StackWalk;
	SYMFUNCTIONTABLEACCESSPROC	SymFunctionTableAccess;
	SYMGETMODULEBASEPROC		SymGetModuleBase;
	SYMGETSYMFROMADDRPROC		SymGetSymFromAddr;
	proc_SymGetLineFromAddr		SymGetLineFromAddr;
	proc_SymGetOptions			SymGetOptions;
	proc_SymSetOptions			SymSetOptions;

	GDebugHelp() :
		#if 1
		GLibrary("dbghelp")
		#else
		GLibrary("imagehlp")
		#endif
	{
		if (LgiGetOs() == LGI_OS_WINNT)
		{
			hProcess = GetCurrentProcess();
		}
		else // Win9x
		{
			hProcess = (HANDLE)GetCurrentProcessId();
		}
		
		SymInitialize = (SYMINITIALIZEPROC) GetAddress("SymInitialize");
		SymCleanup = (SYMCLEANUPPROC) GetAddress("SymCleanup");
		StackWalk = (STACKWALKPROC) GetAddress("StackWalk");
		SymFunctionTableAccess = (SYMFUNCTIONTABLEACCESSPROC) GetAddress("SymFunctionTableAccess");
		SymGetModuleBase = (SYMGETMODULEBASEPROC) GetAddress("SymGetModuleBase");
		SymGetSymFromAddr = (SYMGETSYMFROMADDRPROC) GetAddress("SymGetSymFromAddr");
		SymGetLineFromAddr = (proc_SymGetLineFromAddr) GetAddress("SymGetLineFromAddr");
		SymGetOptions = (proc_SymGetOptions) GetAddress("SymGetOptions");
		SymSetOptions = (proc_SymSetOptions) GetAddress("SymSetOptions");
	}
};

/////////////////////////////////////////////////////////////////////////////
#define sstModule           0x120
#define sstAlignSym         0x125
#define sstSrcModule        0x127
#define sstLibraries        0x128
#define sstGlobalSym        0x129
#define sstGlobalPub        0x12a
#define sstGlobalTypes      0x12b
#define sstSegMap           0x12d
#define sstFileIndex        0x133
#define sstStaticSym        0x134

#if 0
/* Old, crusty value */
#define S_PUB32             0x0203
#endif

#define S_PUB32             0x1009

#include "pshpack1.h"

/*
 * CodeView headers
 */

typedef struct OMFSignature 
{
    char        Signature[4];
    long        filepos;
} OMFSignature;

typedef struct OMFDirHeader 
{
    unsigned short  cbDirHeader;
    unsigned short  cbDirEntry;
    unsigned long   cDir;
    long            lfoNextDir;
    unsigned long   flags;
} OMFDirHeader;

typedef struct OMFDirEntry 
{
    unsigned short  SubSection;
    unsigned short  iMod;
    long            lfo;
    unsigned long   cb;
} OMFDirEntry;


/*
 * sstModule subsection
 */

typedef struct OMFSegDesc 
{
    unsigned short  Seg;
    unsigned short  pad;
    unsigned long   Off;
    unsigned long   cbSeg;
} OMFSegDesc;

/* Must chop off the OMFSegDesc* field, because we need to write this
 * struct out to a file.  If we write the whole struct out, we'll end up
 * with (*OMFSegDesc), not (OMFSegDesc).  See OMFModuleFull.
 */
typedef struct OMFModule 
{
    unsigned short  ovlNumber;
    unsigned short  iLib;
    unsigned short  cSeg;
    char            Style[2];
} OMFModule;

/* Full version, with memory pointers, too.  Use OMFModule for writing out to
 * a file, and OMFModuleFull for reading.  If offsetof() were available, we
 * could use that instead.
 */
typedef struct OMFModuleFull
{
    unsigned short  ovlNumber;
    unsigned short  iLib;
    unsigned short  cSeg;
    char            Style[2];
    OMFSegDesc      *SegInfo;
    char            *Name;
} OMFModuleFull;


/*
 * sstGlobalPub section
 */

/* Header for symbol table.
 */
typedef struct OMFSymHash 
{
    unsigned short  symhash;
    unsigned short  addrhash;
    unsigned long   cbSymbol;
    unsigned long   cbHSym;
    unsigned long   cbHAddr;
} OMFSymHash;

/* Symbol table entry.
 */
typedef struct DATASYM32 
{
    unsigned short  reclen;
    unsigned short  rectyp;
    unsigned long   typind;
    unsigned long   off;
    unsigned short  seg;
} DATASYM32;
typedef DATASYM32 PUBSYM32;

/*
 * sstSegMap section
 */

typedef struct OMFSegMapDesc
{
    unsigned short  flags;
    unsigned short  ovl;
    unsigned short  group;
    unsigned short  frame;
    unsigned short  iSegName;
    unsigned short  iClassName;
    unsigned long   offset;
    unsigned long   cbSeg;
} OMFSegMapDesc;

typedef struct OMFSegMap
{
    unsigned short  cSeg;
    unsigned short  cSegLog;
    OMFSegMapDesc   rgDesc[0];
} OMFSegMap;


/*
 * sstSrcModule section
 */

typedef struct OMFSourceLine
{
    unsigned short  Seg;
    unsigned short  cLnOff;
    unsigned long   offset[1];
    unsigned short  lineNbr[1];
} OMFSourceLine;

typedef struct OMFSourceFile
{
    unsigned short  cSeg;
    unsigned short  reserved;
    unsigned long   baseSrcLn[1];
    unsigned short  cFName;
    char            Name;
} OMFSourceFile;

typedef struct OMFSourceModule
{
    unsigned short  cFile;
    unsigned short  cSeg;
    unsigned long   baseSrcFile[1];
} OMFSourceModule;

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
class PE_Debug
{
public :
	PE_Debug(GStringPipe &dumpBuffer);
	~PE_Debug();

	void ClearReport();
	void DumpDebugInfo( GStringPipe& dumpBuffer, DWORD caller, HINSTANCE hInstance );
	void Display();

private:
	// Report data
	enum { MAX_MODULENAME_LEN = 512, MAX_FILENAME_LEN = 256 };
	char latestModule[ MAX_MODULENAME_LEN ];
	char latestFile[ MAX_FILENAME_LEN ];

	// File mapping data
	HANDLE hFile;
	HANDLE hFileMapping;
	PIMAGE_DOS_HEADER fileBase;

	GDebugHelp *DebugHelp;

	// Pointers to debug information
	PIMAGE_NT_HEADERS NT_Header;

	void ClearFileCache();
	void ClearDebugPtrs();
	void MapFileInMemory( const char* module );
	void FindDebugInfo();
	void DumpSymbolInfo( GStringPipe& dumpBuffer, DWORD relativeAddress );
	void DumpLineNumber( GStringPipe& dumpBuffer, DWORD relativeAddress );
	void *GetDebugHeader();
	PIMAGE_SECTION_HEADER SectionHeaderFromName(const char* name);
	const char* GetSymbolName( PIMAGE_SYMBOL sym );
};

// Add an offset to a pointer and cast to a given type; may be
// implemented as a template function but Visual C++ has some problems.
#define BasedPtr( type, ptr, ofs ) (type)( (DWORD)(ptr) + (DWORD)(ofs) )

PE_Debug::PE_Debug(GStringPipe &dumpBuffer)
{
	// Init file mapping cache
	hFileMapping = 0;
	hFile = INVALID_HANDLE_VALUE;
	fileBase = 0;
	ClearDebugPtrs();
	ClearReport();
	DebugHelp = NEW(GDebugHelp);
	if (DebugHelp)
	{
		if (DebugHelp->SymInitialize)
		{
			if (DebugHelp->SymInitialize(DebugHelp->hProcess, 0, true))
			{
				DWORD dwOpts = DebugHelp->SymGetOptions();
				DWORD Set = DebugHelp->SymSetOptions(dwOpts | SYMOPT_LOAD_LINES | SYMOPT_OMAP_FIND_NEAREST);

				// LgiTrace("SymInitialize Ok, dwOpts=0x%X, Set=0x%X", dwOpts, Set);
			}
			else
			{
				DWORD e = GetLastError();
				dumpBuffer.Print("\nSymInitialize(%p, 0, true) failed with error: 0x%X\n", DebugHelp->hProcess, e);
				DeleteObj(DebugHelp);
			}
		}
		else
		{
			dumpBuffer.Print("\nDbgHelp.DLL wasn't there or didn't load.\n");
			DeleteObj(DebugHelp);
		}
	}
}

PE_Debug::~PE_Debug()
{
	ClearFileCache();
}

void PE_Debug::ClearReport()
{
	latestModule[ 0 ] = 0;
	latestFile[ 0 ] = 0;
}

void PE_Debug::ClearDebugPtrs()
{
	NT_Header = NULL;
}

void PE_Debug::ClearFileCache()
{
	if (fileBase)
	{
		UnmapViewOfFile( fileBase );
		fileBase = 0;
	}
	
	if (hFileMapping != 0)
	{
		CloseHandle( hFileMapping );
		hFileMapping = 0;
	}
	
	if (hFile != INVALID_HANDLE_VALUE)
	{
		CloseHandle( hFile );
		hFile = INVALID_HANDLE_VALUE;
	}
}

void PE_Debug::DumpLineNumber( GStringPipe& dumpBuffer, DWORD relativeAddress )
{
}


const char* PE_Debug::GetSymbolName( PIMAGE_SYMBOL sym )
{
	const int NAME_MAX_LEN = 64;
	static char buf[ NAME_MAX_LEN ] = { 0 };
	if( sym->N.Name.Short != 0 )
	{
		strncpy( buf, (const char*)sym->N.ShortName, 8 );
		buf[ 8 ] = 0;
	}
	else
	{
		//strncpy( buf, stringTable + sym->N.Name.Long, NAME_MAX_LEN );
		buf[ NAME_MAX_LEN - 1 ] = 0;
	}
	return( buf );
}


void PE_Debug::DumpSymbolInfo( GStringPipe& dumpBuffer, DWORD relativeAddress )
{
	// Variables to keep track of function symbols
}

PIMAGE_SECTION_HEADER PE_Debug::SectionHeaderFromName( const char* name )
{
	PIMAGE_SECTION_HEADER section = IMAGE_FIRST_SECTION( NT_Header );
	for( unsigned i = 0; i < NT_Header->FileHeader.NumberOfSections; i++ )
	{
		if( strnicmp( (const char*)section->Name, name, IMAGE_SIZEOF_SHORT_NAME ) == 0 )
			return( section );
		else
			section++;
	}

	return 0;
}

void *PE_Debug::GetDebugHeader()
{
	DWORD debugDirRVA = NT_Header->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_DEBUG].VirtualAddress;
	if( debugDirRVA == 0 )
	{
		return( 0 );
	}

	// The following values must be calculated differently for MS/Borland files
	PIMAGE_DEBUG_DIRECTORY debugDir;
	DWORD size;

	// Borland files have the debug directory at the beginning of a .debug section
	PIMAGE_SECTION_HEADER debugHeader = SectionHeaderFromName( ".debug" );
	if( debugHeader && debugHeader->VirtualAddress == debugDirRVA )
	{
		debugDir = (PIMAGE_DEBUG_DIRECTORY)(debugHeader->PointerToRawData + (DWORD)fileBase);
		size = NT_Header->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_DEBUG].Size *
				sizeof( IMAGE_DEBUG_DIRECTORY );
	}
	else
	// Microsoft debug directory is in the .rdata section
	{
		debugHeader = SectionHeaderFromName( ".rdata" );
		if( debugHeader == 0 )
		{
			return( 0 );
		}
		
		size = NT_Header->OptionalHeader.
		DataDirectory[ IMAGE_DIRECTORY_ENTRY_DEBUG ].Size;
		DWORD offsetInto_rdata = debugDirRVA - debugHeader->VirtualAddress;
		debugDir = BasedPtr(PIMAGE_DEBUG_DIRECTORY, fileBase, debugHeader->PointerToRawData + offsetInto_rdata);
	}

	// look for CodeView debug info
	DWORD debugFormats = size / sizeof( IMAGE_DEBUG_DIRECTORY );
	for( DWORD i = 0; i < debugFormats; i++ )
	{
		if (debugDir->Type == IMAGE_DEBUG_TYPE_CODEVIEW)
		{
			return (void*)((DWORD)fileBase + debugDir->PointerToRawData);
		}
		else
		{
			debugDir++;
		}
	}
	
	return( NULL );
}


void PE_Debug::FindDebugInfo()
{
	ClearDebugPtrs();

	/*
	// Put everything into a try/catch in case the file has wrong fields
	try
	{
		// Verify that fileBase is a valid pointer to a DOS header
		if( fileBase->e_magic == IMAGE_DOS_SIGNATURE )
		{
			// Get a pointer to the PE header
			NT_Header = BasedPtr( PIMAGE_NT_HEADERS, fileBase, fileBase->e_lfanew );

			// Verify that NT_Header is a valid pointer to a NT header
			if( NT_Header->Signature == IMAGE_NT_SIGNATURE )
			{
				// Get a pointer to the debug header if any
				DWORD *DebugHeader = (DWORD*) GetDebugHeader();
				if (DebugHeader)
				{
					char Type[5];
					((DWORD*)Type)[0] = *DebugHeader;
					Type[4] = 0;

					#ifdef _DEBUG
					LgiTrace("Debug Header Type: '%s'", Type);
					#endif

					if (stricmp(Type, "NB10") == 0)
					{
						// Load from .PDB file
						char FileName[256];
						strcpy(FileName, (char*)(DebugHeader+4));
	
						#ifdef _DEBUG
						LgiTrace("PDB file: '%s'\n", FileName);
						#endif
					}
					else if (stricmp(Type, "NB09") == 0 OR
							 stricmp(Type, "NB11") == 0)
					{
						// Load from internal database
					}
				}
				else
				{
					#ifdef _DEBUG
					LgiTrace("No Debug Header");
					#endif
				}
			}
		}
	}
	catch( ... )
	{
		// Header wrong, do nothing
	}
	*/
}

void PE_Debug::MapFileInMemory( const char* module )
{
	ClearFileCache();
	hFile = CreateFile( module,
						GENERIC_READ,
						FILE_SHARE_READ,
						NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						0);

	if( hFile != INVALID_HANDLE_VALUE )
	{
		hFileMapping = CreateFileMapping( hFile, NULL, PAGE_READONLY, 0, 0, NULL );
		if( hFileMapping != 0 )
			fileBase = (PIMAGE_DOS_HEADER)MapViewOfFile( hFileMapping, FILE_MAP_READ, 0, 0, 0 );
	}
	// NB: open files/mapping are closed later in ClearFileCache
}

void PE_Debug::DumpDebugInfo( GStringPipe& dumpBuffer, DWORD caller, HINSTANCE hInstance)
{
	// Avoid to open, map and looking for debug header/symbol table
	// by caching the latest and comparing the actual module with
	// the latest one.
	static char module[MAX_MODULENAME_LEN] = { 0 };
	GetModuleFileName(hInstance, module, MAX_MODULENAME_LEN);
	if (stricmp(latestModule, module))  // New module
	{
		strcpy(latestModule, module);

		if (DebugHelp)
		{
			BYTE symbolBuffer[ sizeof(IMAGEHLP_SYMBOL) + 512 ];
			PIMAGEHLP_SYMBOL pSymbol = (PIMAGEHLP_SYMBOL)symbolBuffer;
			pSymbol->SizeOfStruct = sizeof(symbolBuffer);
			pSymbol->MaxNameLength = 512;

			DWORD symDisplacement = 0;  // Displacement of the input address,
										// relative to the start of the symbol

			IMAGEHLP_LINE Line;
			ZeroObj(Line);
			Line.SizeOfStruct = sizeof(Line);

			DWORD Offset = (DWORD)caller-(DWORD)hInstance;

			if (DebugHelp->SymGetSymFromAddr(DebugHelp->hProcess, caller, &symDisplacement, pSymbol))
			{
				if (DebugHelp->SymGetLineFromAddr(DebugHelp->hProcess, caller, &symDisplacement, &Line))
				{
					dumpBuffer.Print("%p: %s Line: %i\n", caller, Line.FileName, Line.LineNumber);
				}
				else
				{
					dumpBuffer.Print("%p: %s Offset: 0x%X (%hs)\n", caller, module, symDisplacement, pSymbol->Name);
				}
			}
			else
			{
				DWORD e = GetLastError();
				dumpBuffer.Print("%p: %s\n", caller, module);
			}
		}
		else
		{
			dumpBuffer.Print("%p\n", caller);
		}
	}
}

//////////////////////////////////////////////////////////////////////////
void StackDump(GStringPipe &dumpBuffer, DWORD EBP, DWORD EIP )
{
	// The structure of the stack frames is the following:
	// EBP -> parent stack frame EBP
	//        return address for this call ( = caller )
	// The chain can be navigated iteratively; the
	// initial value of EBP is given by the parameter.
	// If EIP != 0, then before we dump the call stack, we
	// dump the same information for EIP. Basically, we
	// consider EIP as the first element of the call stack.
	PE_Debug Debug(dumpBuffer);

	char* separator = "------------------------------------------------------------------\r\n";
	dumpBuffer.Print("\r\nCall stack:\r\n");
	dumpBuffer.Print(separator);

	BOOL EBP_OK = TRUE;
	do
	{
		// Check if EBP is a good address
		// I'm expecting a standard stack frame, so
		// EPB must be aligned on a DWORD address
		// and it should be possible to read 8 bytes
		// starting at it (next EBP, caller).
		if( (DWORD)EBP & 3 )
			EBP_OK = FALSE;

		if( EBP_OK && IsBadReadPtr( (void*)EBP, 8 ) )
			EBP_OK = FALSE;

		if( EBP_OK )
		{
			DWORD caller = (DWORD) (EIP ? (BYTE*)EIP : *((BYTE**)EBP + 1));
			EBP = EIP ? EBP : *(DWORD*)EBP;
			
			if( EIP )
				EIP = 0; // So it is considered just once
		
			// Get the instance handle of the module where caller belongs to
			MEMORY_BASIC_INFORMATION mbi;
			VirtualQuery( (void*)caller, &mbi, sizeof( mbi ) );
			
			// The instance handle is equal to the allocation base in Win32
			HINSTANCE hInstance = (HINSTANCE)mbi.AllocationBase;
			
			// If EBP is valid, hInstance is not 0
			if (hInstance == 0)
				EBP_OK = FALSE;
			else
				Debug.DumpDebugInfo(dumpBuffer, caller, hInstance);
		}
		else
			break; // End of the call chain
	}
	while( TRUE );
	
	Debug.ClearReport();  // Prepare for future calls

	dumpBuffer.Print(separator);
	dumpBuffer.Print("\r\n");
}

#define CODE_DESCR( c ) { c, #c }

static 
struct ExceptionCodeDescr
{
	DWORD code;
	const char* descr;
}
exceptionTable[] =
{
	CODE_DESCR(EXCEPTION_ACCESS_VIOLATION),
	CODE_DESCR(EXCEPTION_ARRAY_BOUNDS_EXCEEDED),
	CODE_DESCR(EXCEPTION_BREAKPOINT),
	CODE_DESCR(EXCEPTION_DATATYPE_MISALIGNMENT),
	CODE_DESCR(EXCEPTION_FLT_DENORMAL_OPERAND),
	CODE_DESCR(EXCEPTION_FLT_DIVIDE_BY_ZERO),
	CODE_DESCR(EXCEPTION_FLT_INEXACT_RESULT),
	CODE_DESCR(EXCEPTION_FLT_INVALID_OPERATION),
	CODE_DESCR(EXCEPTION_FLT_OVERFLOW),
	CODE_DESCR(EXCEPTION_FLT_STACK_CHECK),
	CODE_DESCR(EXCEPTION_FLT_UNDERFLOW),
	CODE_DESCR(EXCEPTION_GUARD_PAGE),
	CODE_DESCR(EXCEPTION_ILLEGAL_INSTRUCTION),
	CODE_DESCR(EXCEPTION_IN_PAGE_ERROR),
	CODE_DESCR(EXCEPTION_INT_DIVIDE_BY_ZERO),
	CODE_DESCR(EXCEPTION_INT_OVERFLOW),
	CODE_DESCR(EXCEPTION_INVALID_DISPOSITION),
	CODE_DESCR(EXCEPTION_NONCONTINUABLE_EXCEPTION),
	CODE_DESCR(EXCEPTION_PRIV_INSTRUCTION),
	CODE_DESCR(EXCEPTION_SINGLE_STEP),
	CODE_DESCR(EXCEPTION_STACK_OVERFLOW)
	// might be extended with compiler-specific knowledge of
	// "C++ Exception" code[s]
};

LONG __stdcall GApp::_ExceptionFilter(LPEXCEPTION_POINTERS e)
{
	LONG res = 0;

	SetUnhandledExceptionFilter(0); // We can't handle crashes within
									// ourself, so let the default handler
									// do it.

	EnterCriticalSection(&StackTraceSync);

	DWORD exceptionCode = e->ExceptionRecord->ExceptionCode;

	GStringPipe Buf;
	Buf.Empty();

	/*
	try
	{
	*/

		Buf.Print("Unhandled Exception\r\n  Code: %x\r\n", exceptionCode);

		const char * descr = 0;
		int n = sizeof(exceptionTable) / sizeof(ExceptionCodeDescr);

		for (int i = 0; i < n; i++)
		{
			if (exceptionTable[i].code == exceptionCode)
			{
				descr = exceptionTable[i].descr;
				break;
			}
		}
		Buf.Print("  Description: %s\r\n", descr ? descr : "(unknown)");
		
		StackDump(Buf, e->ContextRecord->Ebp, e->ContextRecord->Eip);

		char *Msg = Buf.NewStr();
		if (Msg)
		{
			GFile f;
			char Output[256];
			LgiGetExePath(Output, sizeof(Output));
			strcat(Output, DIR_STR);
			strcat(Output, "CrashData.txt");
			if (f.Open(Output, O_WRITE))
			{
				f.Seek(0, SEEK_END);
				f.Write(Msg, strlen(Msg));
				f.Close();
			}

			int Result = LgiMsg(AppWnd, Msg, "Error: Exception", MB_YESNOCANCEL);
			switch (Result)
			{
				case IDYES: // Abort
					res = EXCEPTION_EXECUTE_HANDLER;
					break;
				case IDNO: // Debug
					res = EXCEPTION_CONTINUE_SEARCH;
					break;
				default:
					// Not reached, cannot use assert!
					MessageBeep(0);
			}
		}

	/*
	}
	catch (...)
	{
		#ifdef _DEBUG
		LgiTrace("_ExceptionFilter crashed.");
		#endif
	}
	*/

	LeaveCriticalSection(&StackTraceSync);

	return res;
}

