#include "Lgi.h"
#include <COMMCTRL.H>

///////////////////////////////////////////////////////////////////////////////////////////
GProgress::GProgress(int id, int x, int y, int cx, int cy, char *name) :
	GControl(LGI_PROGRESS),
	ResObject(Res_Progress)
{
	SetClass(LGI_PROGRESS);
	SetId(id);
	GRect r(x, y, x+cx, y+cy);
	SetPos(r);
	if (name) GControl::Name(name);

	SetStyle(GetStyle() | WS_CHILD | WS_TABSTOP | WS_VISIBLE | PBS_SMOOTH);
	if (SubClass)
	{
		SubClass->SubClass(PROGRESS_CLASS);
	}
}

GProgress::~GProgress()
{
}

void GProgress::SetLimits(int64 l, int64 h)
{
	Low = l;
	High = h;
	if (Handle())
	{
		SendMessage(Handle(), PBM_SETRANGE32, Low, High);
	}
}

int64 GProgress::Value()
{
	return Val;
}

void GProgress::Value(int64 v)
{
	Val = v;
	if (Handle())
	{
		SendMessage(Handle(), PBM_SETPOS, (WPARAM) Val, 0);
	}
}

int GProgress::OnEvent(GMessage *Msg)
{
	return GControl::OnEvent(Msg);
}

bool GProgress::SetForegroundFill(GViewFill *Fill)
{
	if (_View AND Fill)
	{
		COLOUR c32 = Fill->GetFlatC32();
		SendMessage(_View, PBM_SETBARCOLOR, 0, RGB(R32(c32), G32(c32), B32(c32)));
	}

	return GView::SetForegroundFill(Fill);
}