/*hdr
**      FILE:           Ftp.h
**      AUTHOR:         Matthew Allen
**      DATE:           7/9/99
**      DESCRIPTION:    i.Ftp header file
**
**      Copyright (C) 1999 Matthew Allen
**              fret@memecode.com
*/

// Includes
#include <stdio.h>
#include <stdlib.h>
#include "Lgi.h"
#include "GDragAndDrop.h"
#include "INet.h"
#include "GList.h"

// Resource ID's
#include "resource.h"
#include "resdefs.h"

// Gui controls
#include "GTextView3.h"
#include "GPanel.h"
#include "GProgressStatusPane.h"
#include "GDataDlg.h"
#include "GXmlTreeUi.h"

// Ftp protocol
#include "IFtp.h"

////////////////////////////////////////////////////////////////////////////////////////////
#define	VER							2.00

#define FTP_COL_WRITE				Rgb24(0,0,255)
#define FTP_COL_READ				Rgb24(0,128,0)
#define FTP_COL_ERROR				Rgb24(255,0,0)
#define FTP_COL_INFO				Rgb24(0,0,0)

////////////////////////////////////////////////////////////////////////////////////////////
// Defines

#define GFSV_DIR					(M_USER+1200)
#define GFSV_LIST					(M_USER+1201)
#define FTP_SAVE_FILE				(M_USER+1202)
#define M_ON_CONNECT				(M_USER+1203)
#define M_ON_DISCONNECT				(M_USER+1204)

// Account props
#define OPT_AccountName				"AccName"	// (char*)
#define OPT_RemoteHost				"Host"		// (char*)
#define OPT_Port					"Port"		// (int)
#define OPT_UserName				"User"		// (char*)
#define OPT_Password				"Key"		// (char*)
#define OPT_Anonymous				"Anon"		// (bool)(int)
#define OPT_LocalDir				"Local"		// (char*)
#define OPT_RemoteDir				"Remote"	// (char*)
#define OPT_UseActive				"UseActive"	// (bool)
#define OPT_NormalList				"NormList"	// (bool)
#define OPT_SFtp					"SFtp"

#define OPT_Socks5Server			"Socks5Server"
#define OPT_Socks5UserName			"Socks5UserName"
#define OPT_Socks5Password			"Socks5Password"

#define OPT_ConfirmDeletes			"ConfirmDel"
#define OPT_ConfirmLinks			"ConfirmLinks"
#define OPT_AsciiTypes				"AsciiTypes"
#define OPT_BinaryTypes				"BinTypes"
#define OPT_ResizeToContent			"ResizeCols"
#define OPT_Language				"Lang"
#define OPT_DblClickAction			"DblClick"
#define OPT_LocalFolder				"LocalFolder"

#define OPT_LogFile					"Log"
#define OPT_ShowHidden				"ShowHidden"
#define OPT_WndPos					"WndPos"

// window messages
#define	IDM_OPEN					111
#define	IDM_LOAD					112
#define	IDM_SAVE					113
#define	IDM_SAVEAS					114
#define IDM_STOP					115
#define	IDM_CLOSE					118

#define IDM_UPLOAD					122
#define IDM_DOWNLOAD				123
#define	IDM_LIST					125
// #define IDM_UP						126
#define IDM_CREATE_DIR				127
#define IDM_DELETE_DIR				128
// #define IDM_DELETE					129
#define IDM_EXECUTE					130
// #define IDM_RENAME					131
#define IDM_ABORT					132
#define IDM_SETPERMS				132
#define IDM_CD						133
// #define IDM_TRANSFER				134
#define IDM_TRANSFER_MASK			135
#define IDM_VIEW_TEXT				136
#define	IDM_UNDO					201
#define	IDM_REDO					202
#define	IDM_CUT						203
#define	IDM_COPY					204
#define	IDM_PASTE					205
#define	IDM_FIND					206
#define IDM_TO						311
#define IDM_CC						312
#define IDM_EMPTY					313
#define IDM_EDIT					314
#define IDM_SHOW_HIDDEN				315
#define IDM_PROPERTIES				402
#define IDM_ACCOUNT_BASE			20000

// File utility macros
#define SizeStrField(Var)			(sizeof(short)+SizeofStr(Var))
#define SizeIntField(Var)			(sizeof(short)+sizeof(ulong)+sizeof(Var))
#define SizeObjField(Var)			(sizeof(short)+sizeof(ulong)+(Var).Sizeof())

#define WriteStrField(Id, Var)		f << ((short)Id); WriteStr(f, Var)
#define WriteIntField(Id, Var)		f << ((short)Id); f << ((ulong)sizeof(Var)); f << Var
#define WriteObjField(Id, Var)		f << ((short)Id); f << ((ulong)(Var).Sizeof()); (Var).Serialize(f, Write)

#define ReadStrField(Id, Var)		case Id: Var = ReadStr(f); break
#define ReadIntField(Id, Var)		case Id: f >> FieldSize; f >> Var; break
#define ReadObjField(Id, Var)		case Id: f >> FieldSize; (Var).Serialize(f, Write); break

// Misc
#define	MainWnd						((AppWnd*)GApp::ObjInstance()->AppWnd)
#undef	Opposite

extern char AppName[];

////////////////////////////////////////////////////////////////////////////////////////////
// Functions

// Misc
extern int SizeOfFile(char *FileName);
extern char *OsName();
extern void GetFullAppName(char *s);
extern void GetFolderId(char *s);
extern void Error(char *str, ...);
extern char *ObsurePsw(char *Pwd, bool Ob);

#include "FileTransferProgress.h"

////////////////////////////////////////////////////////////////////////////////////////////
// Classes
class AppWnd;

/////////////////////////////////////////////////////////////////////////////
#define IDC_OVERWRITE			100
#define IDC_DIR					101
#define IDC_MOUNT				102

class ResumeDlg : public GDialog
{
public:
	ResumeDlg(GViewI *parent, IFtpEntry *e, bool Resumable);
	int OnNotify(GViewI *Ctrl, int Flags);
};

/////////////////////////////////////////////////////////////////////////////
class AboutDlg : public GDialog {

	char Text[512];

public:
	AboutDlg(GViewI *parent);
	int OnNotify(GViewI *Ctrl, int Flags);
};

class App : public GApp
{
public:
	App(char *Mime, OsAppArguments &AppArgs) :
		GApp(Mime, AppArgs)
	{
	}
};

#include "GLog.h"
class GLogPanel : public GPanel, public GLog
{
	RLogView *View;

public:
	GLogPanel();
	~GLogPanel();

	bool Pour(GRegion &r);
};

#define TASK_ListElements			1000
#define TASK_Cd						1001
#define TASK_CreateDir				1002
#define TASK_Delete					1003
#define TASK_SetPerms				1004
#define TASK_ExecuteFile			1005
#define TASK_ViewTextFile			1006
#define TASK_ProcessClick			1007
#define TASK_Login					1008
#define TASK_Transfer				1009
#define TASK_Rename					1010
#define TASK_TransferPattern		1011
#define TASK_Exit					1012
#define TASK_Noop					1013

class FtpCmd
{
public:
	int Cmd;
	char Arg[MAX_PATH]; // for buffering if you need it
	char Arg2[MAX_PATH];
	int Int, Int2;
	bool ForceRemote;
	class GFileSystemView *View;

	char *Str;
	GMouse Click;
	IFtpEntry *Entry;
	GSocketI *Connection;

	List<FtpCmd> OnSuccess;
	List<FtpCmd> OnFail;

	void _New()
	{
		Cmd = 0;
		Str = 0;
		View = 0;
		Arg[0] = 0;
		Arg2[0] = 0;
		Entry = 0;
		Connection = 0;
		Int = Int2 = 0;
		ForceRemote = false;
	}
	
	FtpCmd()
	{
		_New();
	}

	FtpCmd(char *s)
	{
		_New();
		
		if (s)
		{
			Str = Arg;
			strcpy(Arg, s);
		}
	}

	~FtpCmd()
	{
		DeleteObj(Entry);
		OnSuccess.DeleteObjects();
		OnFail.DeleteObjects();
	}
};

class FtpWorkerThread : public GThread, public GSemaphore
{
	List<FtpCmd> Cmds;
	bool Loop;
	bool Working;

public:
	FtpWorkerThread();
	~FtpWorkerThread();

	// This loops around looking for commands to send
	int Main();
	
	// This que's a command for processing by the worker thread
	// The command will get poped off the que and sent to the
	// calling object.
	void PostCmd(FtpCmd *Cmd);

	// Props
	int GetCmdsLeft();
	void SetLoop(bool i);
	bool IsWorking();
};

class FtpList : public GList
{
public:
	class GFileSystemView *View;

	FtpList(int id, int x, int y, int cx, int cy) :
		GList(id, x, y, cx, cy)
	{
		View = 0;
	}

	void OnColumnClick(int Col, GMouse &m);
};

class GFileSystemView : public GLayout, public List<IFtpEntry>
{
	friend int FtpItemCompare(GListItem *a, GListItem *b, int Data);

protected:
	GImageList *ImageList;
	GToolBar *Commands;
	AppWnd *Wnd;
	bool Listing;
	char *CurFolder;

	int SortCol;
	bool SortAscend;

	GCommand CmdCreateDir;
	GCommand CmdDelete;
	GCommand CmdRenameFile;
	GCommand CmdSetPerms;
	GCommand CmdExecute;
	GCommand CmdViewText;
	GCommand CmdTransfer;
	GCommand CmdRefresh;
	GCommand CmdCdup;

public:
	GEdit *Edit;
	FtpList *Lst;
	GButton *Dir;
	GCombo *Mount;

	GFileSystemView *Opposite;
	FtpWorkerThread *Worker;

	GFileSystemView(AppWnd *Wnd, GImageList *ImageList, bool Local);
	~GFileSystemView();

	// Data
	void GetDir(char *Path, char *Append = 0);
	int GetSelection(List<IFtpEntry> &Sel);
	void PostCmd(FtpCmd *Cmd);
	virtual bool IsLocal() { return false; }
	virtual bool IsCmdLocal(int Cmd) { return false; }
	virtual void EnableCommands(bool Enabled) {}

	// Menu
	virtual void GetMenuCommands(IFtpEntry *e, GSubMenu *RClick);
	virtual void OnMenuCommand(IFtpEntry *e, int Cmd);

	// Window
	bool Attach(GViewI *p);
	bool Pour(GRegion &r);
	void OnPaint(GSurface *pDC);
	int OnNotify(GViewI *Ctrl, int Flags);
	void OnColumnClick(int Col, GMouse &m);
	virtual void OnClick(IFtpEntry *e, GMouse *m);

	// Methods
	//
	//		These functions are called from the worker thread
	//		not the main UI thread. This is acheived by posting
	//		a command to the worker thread which then calls us
	//		back when it's ready to process it

	// Process a general command
	void DoCmd(FtpCmd *Cmd);

	// Command handlers
	virtual bool ListElements() { return false; }
	virtual bool Cd(char *Dir = 0, bool RefeashList = true) { return false; } // 0 = up
	virtual bool CreateDir(char *Dir) { return false; }
	virtual bool Delete(IFtpEntry *e) { return false; }
	virtual bool SetPerms(IFtpEntry *e, int Perms) { return false; }
	virtual bool ExecuteFile(char *File) { return false; }
	virtual bool TransferFile(FtpCmd *c)
	{
		// Arguments:
		//		Cmd = TASK_Transfer
		//		Arg = <full path name>
		//		Entry = <entry to transfer>
		//		Str = <directory transfer mask>
		//		Int = <force dir transfer>
		//		Int2 = <overwrite>
		//
		// Either Arg or Entry must be valid
		return false;
	}
	virtual bool RenameFile(char *From, char *To) { return false; }
	virtual bool ViewTextFile(char *File) { return false; }
	virtual bool ProcessClick(IFtpEntry *e, GMouse *m) { return false; }
	virtual bool TransferFilePattern(FtpCmd *c);

	// Worker
	virtual IFtpEntry *HasDir(char *Name);
	virtual class DirListItem *HasEntry(char *Name);
	virtual bool TransferDir(IFtpEntry *e, char *Mask = 0);
	virtual bool DeleteDir(IFtpEntry *e);
	virtual char DirChar() { return DIR_CHAR; }
	virtual void OnDeviceChange() {}
};

class GLocalFS : public GFileSystemView
{
public:
	GLocalFS(AppWnd *Wnd, GImageList *ImageList);

	bool IsLocal() { return true; }
	bool IsCmdLocal(int Cmd);
	void OnItemSelect(GListItem *Item);
	void EnableCommands(bool Enabled);

	bool ListElements();
	bool Cd(char *Dir = 0, bool RefeashList = true);
	bool CreateDir(char *Dir);
	bool Delete(IFtpEntry *e);
	bool SetPerms(IFtpEntry *e, int Perms);
	bool ExecuteFile(char *File);
	bool TransferFile(FtpCmd *c);
	bool RenameFile(char *From, char *To);
	bool ViewTextFile(char *File);
	bool ProcessClick(IFtpEntry *e, GMouse *m);
	void OnDeviceChange();
};

class GRemoteFS : public GFileSystemView
{
public:
	GRemoteFS(AppWnd *Wnd, GImageList *ImageList);

	bool IsCmdLocal(int Cmd);
	void OnItemSelect(GListItem *Item);
	void EnableCommands(bool Enabled);

	bool ListElements();
	bool Cd(char *Dir = 0, bool RefeashList = true);
	bool CreateDir(char *Dir);
	bool Delete(IFtpEntry *e);
	bool SetPerms(IFtpEntry *e, int Perms);
	bool TransferFile(FtpCmd *c);
	bool RenameFile(char *From, char *To);
	bool ProcessClick(IFtpEntry *e, GMouse *m);

	char DirChar() { return '/'; }
};

class ILog {

	// Logging
	GLog *Logger;
	Progress *Info;
	bool Logging;
	
public:
	ILog(GLog *log);
	~ILog();

	// Logging
	void WriteLog(char *s, int Len, COLOUR c);

	void LogRead(char *Data, int Len);
	void LogWrite(char *Data, int Len);
	void LogError(int ErrorCode, char *ErrorDescription);
	void LogInformation(char *Str);
	int LogSetParameter(int Which, int What);
};

class ILogConnection : public ILog, public GSocket
{
	AppWnd *Wnd;

public:
	ILogConnection(GLog *log, AppWnd *wnd);

	void OnDisconnect();
	void OnRead(char *Data, int Len);
	void OnWrite(char *Data, int Len);
	void OnError(int ErrorCode, char *ErrorDescription);
	void OnInformation(char *Str);
	int SetParameter(int Which, int What);
};

class ISocks5LogConnection : public ILog, public GSocks5Socket
{
	AppWnd *Wnd;

public:
	ISocks5LogConnection(	char *proxy, int port, char *username, char *password,
							GLog *log, AppWnd *wnd);

	void OnDisconnect();
	void OnRead(char *Data, int Len);
	void OnWrite(char *Data, int Len);
	void OnError(int ErrorCode, char *ErrorDescription);
	void OnInformation(char *Str);
	int SetParameter(int Which, int What);
};

class DirListItem : public GListItem, public GDragDropSource
{
	GFileSystemView *View;
	char SizeStr[32];

public:
	IFtpEntry *Entry;

	DirListItem(IFtpEntry *entry, GFileSystemView *View);
	~DirListItem();

	bool GetSel(List<DirListItem> &e);
	IFtpEntry *GetEntry() { return Entry; }
	char *GetText(int i);
	int GetImage(int Flags = 0);
	void OnMouseClick(GMouse &m);
	bool OnKey(GKey &k);

	// d'n'd
	bool OnBeginDrag(GMouse &m);
	bool GetData(GVariant *Data, char *Format);
	bool GetFormats(List<char> &Formats);
};

////////////////////////////////////////////////////////////////////////
class FtpAcc
{
public:
	GXmlTag *Tag;

	FtpAcc(GXmlTag *tag = 0)
	{
		Tag = tag ? tag : NEW(GXmlTag("Account"));

		/*		
		// Force the types
		GVariant v("");
		Tag->SetValue(OPT_AccountName, v);
		Tag->SetValue(OPT_RemoteHost, v);
		Tag->SetValue(OPT_UserName, v);
		Tag->SetValue(OPT_Password, v);
		Tag->SetValue(OPT_LocalDir, v);
		Tag->SetValue(OPT_RemoteDir, v);
		v = (int)0;
		Tag->SetValue(OPT_Port, v);
		Tag->SetValue(OPT_Anonymous, v);
		Tag->SetValue(OPT_UseActive, v);
		Tag->SetValue(OPT_NormalList, v);
		Tag->SetValue(OPT_SFtp, v);
		*/
	}
};

class AppWnd :
	public GWindow,
	public IFtpDataPipe,
	public FileTransferWindow
	#ifdef WIN32
	, public GDragDropTarget
	#endif
{
	friend class HttpThread;
	friend class GRemoteFS;
	friend class GFileSystemView;

	class AppWndPrivate *d;

protected:
	#ifdef WIN32
	static GWin32Class Class;
	#endif

	bool			Connecting;
	bool			Restart;

	// UI
	GStatusBar		*Status;
	GStatusPane		*StatusInfo[_STATUS_MAX];
	GSubMenu		*File;
	GSubMenu		*Edit;
	GSubMenu		*AccountLst;
	GSubMenu		*Help;
	GMenuItem		*Modes[2];
	GToolBar		*Commands;

	// Commands
	GCommand		CmdConnect;
	GCommand		CmdDisconnect;
	GCommand		CmdAbort;
	GCommand		CmdHttp;

	// Storage
	int MaxDataRate; // in bytes / second

	// Main view
	GImageList		*ImageList;
	GSplitter		*Splitter;
	GLogPanel		*LogPanel;

	GFileSystemView	*Local;
	GFileSystemView *Remote;
	FileTransferProgress *Progress;

	FtpWorkerThread	*Worker;
	GThread *Http;

	// Vars
	GNetwork		Sockets;
	GSocketI		*Connection;
	IFileProtocol	*Ftp;
	int64			LastCmd;
	bool			BinaryMode;

	// Methods
	void			SetupUi();
	void			ResetThread();
	void			UpdateMenus();
	FtpAcc			*ArgToAccount(char *Arg, char **File);

public:
	AppWnd();
	~AppWnd();

	bool GetBinaryMode(char *Name);

	// ---------------------------------------------------------------------
	// Methods
	GXmlTag *GetOptions();
	void EnableCommands(bool Enabled);
	void Serialize(bool Write);
	// void ReadProperties(XmlTag *t, ObjProperties *a);
	// void WriteProperties(GFile &F, ObjProperties *Props, char *KeyName);
	void OnConnect();
	void OnDisconnect();
	void SetTransfer(bool On);
	void ConnectTo(FtpAcc *Account);
	void OnCmd(FtpCmd *Cmd);
	void DoCmdLine();
	void OnUrl(char *Url);
	void IsValid();
	bool ShowHiddenFiles();
	IFileProtocol *GetFtp() { return Ftp; }
	
	// Data throttle
	void SetDataRate(int Percent = 100);
	int WritePipe(GStream *c, char *Data, int Len, int Flags);
	int ReadPipe(GStream *c, char *Data, int Len, int Flags);

	// ---------------------------------------------------------------------
	// Window
	int OnNotify(GViewI *Ctrl, int Flags);
	int OnEvent(GMessage *Msg);
	int OnCommand(int Cmd, int Event, OsView Handle);
	bool OnRequestClose(bool OsShuttingDown);
	void OnPulse();
	void OnScheduleChanged(char *Xml);

	// Drag'n'drop
	int OnDrop(char *Format, GVariant *Data, GdcPt2 Pt, int KeyState);
	int WillAccept(List<char> &Formats, GdcPt2 Pt, int KeyState);
};

class ConnectDlg : public GDialog, public GXmlToUi
{
	AppWnd *App;
	List<FtpAcc> *Accounts;
	FtpAcc *Temp, *Cur;
	int Index;
	GCombo *AccountCombo;
	GXmlToUi AppOpts;

	FtpAcc *GetAccount(char *Name);
	void LoadAccountList();

public:
	FtpAcc *Account;

	ConnectDlg(AppWnd *parent, List<FtpAcc> *accounts);
	~ConnectDlg();

	void Serialize(bool Write);
	int OnNotify(GViewI *Ctrl, int Flags);
};

extern ushort Win32Perms[];
extern ushort UnixPerms[];
class PermsDlg : public GDialog
{
	bool Win32;
	GCheckBox *Chk[9];
	int *InitFlags;

public:
	PermsDlg(GViewI *parent, bool win32, int Three, int *Init = 0, char *User = 0, char *Group = 0);
	int OnNotify(GViewI *Ctrl, int Flags);
};

#include "HttpDlg.h"
