#include "Ftp.h"

FtpWorkerThread::FtpWorkerThread()
{
	Loop = true;
	Working = false;

	Run();
}

FtpWorkerThread::~FtpWorkerThread()
{
	Loop = false;
	while (NOT IsExited())
	{
		LgiSleep(50);
	}
}

int FtpWorkerThread::Main()
{
	do
	{
		LgiSleep(100);
		
		if (LockWithTimeout(50))
		{
			Working = true;

			FtpCmd *Cmd = Cmds.First();
			if (Cmd)
			{
				Cmds.Delete(Cmd);
			}

			Unlock();

			if (Cmd)
			{
				if (Cmd->View)
				{
					Cmd->View->DoCmd(Cmd);
				}
				DeleteObj(Cmd);
			}

			Working = false;
		}
	}
	while (Loop);

	return 0;
}

void FtpWorkerThread::PostCmd(FtpCmd *Cmd)
{
	if (Cmd AND Lock())
	{
		Cmds.Insert(Cmd);
		Unlock();

		Run();
	}
}

void FtpWorkerThread::SetLoop(bool i)
{
	if (Lock())
	{
		Loop = i;
		Unlock();
	}
}

bool FtpWorkerThread::IsWorking()
{
	return Working;
}

int FtpWorkerThread::GetCmdsLeft()
{
	int Status = 0;
	if (Lock())
	{
		Status = Cmds.Length();
		Unlock();
	}
	return Status;
}

