#ifndef __HTTP_DLG_H
#define __HTTP_DLG_H

#define OPT_HttpUrl			"HttpUrl"
#define OPT_HttpFile		"HttpFile"
#define OPT_HttpProxyOn		"ProxyOn"
#define OPT_HttpProxy		"ProxyServer"
#define OPT_HttpProxyUser	"ProxyUser"
#define OPT_HttpProxyPass	"ProxyPass"

struct HttpParams
{
	char *Url;
	char *File;
	char *Proxy;
	char *UserName;
	char *Password;
	int64 StartFromByte;
	bool NoCache;

	HttpParams()
	{
		Url = 0;
		File = 0;
		Proxy = 0;
		UserName = 0;
		Password = 0;
		StartFromByte = 0;
		NoCache = 0;
	}

	~HttpParams()
	{
		DeleteArray(Url);
		DeleteArray(File);
		DeleteArray(Proxy);
		DeleteArray(UserName);
		DeleteArray(Password);
	}
};

class HttpDlg : public GDialog, public HttpParams
{
	AppWnd *Parent;

	void SetResumable(bool r);
	void SetRollback(bool r);

public:
	HttpDlg(AppWnd *parent, char *Default);
	~HttpDlg();

	void OnCreate();
	int OnNotify(GViewI *Ctrl, int Flags);
};

class HttpThread : public GThread
{
	AppWnd *Parent;
	Progress *Prog;
	GLogPanel *LogPanel;
	HttpParams *Dlg;

public:
	HttpThread(AppWnd *parent, HttpParams *dlg);
	~HttpThread();
	int Main();
};

#endif
