#ifndef _ISFTP_H_
#define _ISFTP_H_

#include "IFtp.h"

class SFtp : public IFileProtocol
{
	class SFtpPrivate *d;

public:
	SFtp(GViewI *Parent, int DisconnectMsg);
	~SFtp();

	// Properties
	bool IsForceActive();
	void IsForceActive(bool i);
	bool IsLongList();
	void IsLongList(bool i);
	bool IsShowHidden();
	void IsShowHidden(bool i);
	Progress *GetMeter();
	void SetMeter(Progress *m);
	bool GetAuthed();

	// Data
	GSocketI *Handle();
	
	// Connection
	FtpOpenStatus Open(GSocketI *S, char *RemoteHost, int Port, char *User, char *Password);
	bool Close();
	bool IsOpen();
	void Noop();

	// Directory
	bool GetDir(char *Dir);
	bool SetDir(char *Dir);
	bool CreateDir(char *Dir);
	bool DeleteDir(char *Dir);
	bool ListDir(List<IFtpEntry> *Dir);
	bool UpDir();
	
	// File
	bool DeleteFile(char *Remote);
	bool DownloadFile(char *Local, IFtpEntry *Remote, bool Binary = true);
	bool UploadFile(char *Local, char *Remote, bool Binary = true);
	bool RenameFile(char *From, char *To);
	bool SetPerms(char *File, int Perms);
	bool ResumeAt(int64 Pos);
	void Abort();
};

#endif