#include "Lgi.h"
#include "Ftp.h"
#include "GCheckBox.h"

ushort Win32Perms[] = { IFTP_READ, IFTP_ARCHIVE, IFTP_HIDDEN, IFTP_SYSTEM };
ushort UnixPerms[] = {	IFTP_READ, IFTP_WRITE, IFTP_EXECUTE, IFTP_GRP_READ,
						IFTP_GRP_WRITE, IFTP_GRP_EXECUTE, IFTP_GLOB_READ,
						IFTP_GLOB_WRITE, IFTP_GLOB_EXECUTE };

PermsDlg::PermsDlg(	GViewI *parent,
					bool win32,
					int Three,
					int *Init,
					char *User,
					char *Group)
{
	InitFlags = Init;
	Win32 = win32;
	SetParent(parent);
	ZeroObj(Chk);

	if (Win32)
	{
		if (LoadFromResource(IDD_WIN32_PERMS))
		{
			int Ctrl[] = { IDC_READ_ONLY, IDC_ARCHIVE, IDC_HIDDEN, IDC_SYSTEM };
			for (int i=0; i<CountOf(Ctrl); i++)
			{
				Chk[i] = dynamic_cast<GCheckBox*>(FindControl(Ctrl[i]));
				if (Chk[i])
				{
					Chk[i]->ThreeState(Three);
					Chk[i]->Value(Init[i]);
				}
			}
		}
	}
	else
	{
		if (LoadFromResource(IDD_UNIX_PERMS))
		{
			int Ctrl[] =
			{
				IDC_PERM_0,
				IDC_PERM_1,
				IDC_PERM_2,
				IDC_PERM_3,
				IDC_PERM_4,
				IDC_PERM_5,
				IDC_PERM_6,
				IDC_PERM_7,
				IDC_PERM_8,
			};
			for (int i=0; i<CountOf(Ctrl); i++)
			{
				Chk[i] = dynamic_cast<GCheckBox*>(FindControl(Ctrl[i]));
				if (Chk[i])
				{
					Chk[i]->ThreeState(Three);
					Chk[i]->Value(Init[i]);
				}
			}
			if (Three)
			{
				SetCtrlName(IDC_USER, "...");
				SetCtrlName(IDC_GROUP, "...");
			}
			else
			{
				SetCtrlName(IDC_USER, User);
				SetCtrlName(IDC_GROUP, Group);
			}
		}
	}

	MoveToCenter();
}

int PermsDlg::OnNotify(GViewI *Ctrl, int Flags)
{
	switch (Ctrl->GetId())
	{
		case IDOK:
		{
			int Flags = Win32 ? 4 : 9;
			for (int i=0; i<Flags; i++)
			{
				InitFlags[i] = Chk[i]->Value();
			}
			// fall thru
		}
		case IDCANCEL:
		{
			EndModal(Ctrl->GetId());
			break;
		}
	}

	return 0;
}

