#include "Lgi.h"
#include "Ftp.h"
#include "GTextLabel.h"
#include "GButton.h"

ResumeDlg::ResumeDlg(GViewI *parent, IFtpEntry *e, bool Resumable)
{
	GRect p(0, 0, 340, 80);
	SetParent(parent);
	if (e)
	{
		char Str[256];
		sprintf(Str, LgiLoadString(IDS_FILE_EXISTS), e->Name);

		GText *t;
		Children.Insert(t = NEW(GText(-1, 10, 10, -1, -1, Str)));
		p.Dimension(max(t->X()+25, 340), p.Y()+t->Y());
		
		int y = 40;
		GArray<GButton*> Btns;
		Btns[Btns.Length()] = NEW(GButton(IDC_OVERWRITE, 0, y, 80, 20, LgiLoadString(IDS_OVERWRITE)));
		if (Resumable)
		{
			Btns[Btns.Length()] = NEW(GButton(IDC_RESUME, 0, y, 60, 20, LgiLoadString(IDS_RESUME)));
		}
		Btns[Btns.Length()] = NEW(GButton(IDCANCEL, 0, y, 60, 20, LgiLoadString(IDS_CANCEL)));
		
		int Width = 0, i;
		for (i=0; i<Btns.Length(); i++)
		{
			Width += Btns[i]->X() + (i ? 10 : 0);
		}

		int x = (p.X() - Width) / 2;
		for (i=0; i<Btns.Length(); i++)
		{
			GRect r = Btns[i]->GetPos();
			r.Offset(x, 0);
			Btns[i]->SetPos(r);
			Children.Insert(Btns[i]);
			x += r.X() + 10;
		}

		SetPos(p);
		MoveToCenter();
	}
}

int ResumeDlg::OnNotify(GViewI *Ctrl, int Flags)
{
	switch (Ctrl->GetId())
	{
		case IDC_OVERWRITE:
		case IDC_RESUME:
		case IDCANCEL:
		{
			EndModal(Ctrl->GetId());
			break;
		}
	}

	return 0;
}

